#pragma once

#include "ClientDataPackage.hpp"
#include "ESPNow.hpp"
#include "Time.hpp"
#include "esp_log.h"
#include <Arduino.h>
#include <ArduinoJson.h>
#include <ESP32Time.h>
#include <esp_now.h>
#include <utility>

// Format of the message sent from host to client_satellite
// if more things are sent from the host the name might not be accurate anymore
class Message {
  public:
	explicit Message(ClientDataPackage data);

	Message(MeasurementData const &data, const SensorInformation &information, unsigned long timestamp);
	esp_err_t send() const;
	[[nodiscard]] std::string getMessageAsMinifiedJsonString() const;

  private:
	ClientDataPackage clientDataPackage;
	uint8_t recipient[6]{};
};
